animeflix_project/urls.py
import debug_toolbar
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path

from animeflix_project import settings

urlpatterns = [
    path('', include('animeflix_app.urls')),
    path('auth/', include('auth_app.urls')),
    path('forum/', include('forum.urls')),
    path('admin/', admin.site.urls),
    path('__debug__/', include(debug_toolbar.urls)),

] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

auth_app/urls.py
from django.urls import path

from auth_app.views import LoginFormView, RegistrationFormView, EditAccountView, ProfileView, \
    Logout, DeleteAccountView, ResetPasswordView

urlpatterns = [
    path('login', LoginFormView.as_view(), name='login'),
    path('logout', Logout.as_view(), name='logout'),
    path('set-password', ResetPasswordView.as_view(), name='reset_pwd'),
    path('registration', RegistrationFormView.as_view(), name='registration'),
    path('profile', ProfileView.as_view(), name='profile'),
    path('edit-profile<pk>', EditAccountView.as_view(), name='edit_account'),
    path('delete-account<pk>', DeleteAccountView.as_view(), name='delete_account')
]

forum/urls.py
from django.urls import path

from .views import ForumPageView, ThreadDetailView, NewThreadFormView, EditPostFormView, NewPostFormView, \
    EditThreadTitle, DeleteThreadView, DeletePostView

urlpatterns = [
    path('', ForumPageView.as_view(), name='forum'),
    path('new-thread', NewThreadFormView.as_view(), name='new_thread'),
    path('thread<pk>', ThreadDetailView.as_view(), name='thread_detail'),
    path('thread<pk>/edit-title', EditThreadTitle.as_view(), name='edit_title'),
    path('thread<pk>/delete', DeleteThreadView.as_view(), name='delete_thread'),
    path('thread<pk>/new-post', NewPostFormView.as_view(), name='new_post'),
    path('thread<pk>/new-post&reply-to=post<int:id_quote>', NewPostFormView.as_view(), name='reply_post'),
    path('thread<pk>/edit-post<int:id_post>', EditPostFormView.as_view(), name='edit_post'),
    path('thread<id_thread>/delete-post<pk>', DeletePostView.as_view(), name='delete_post')
]

animeflix_app/models.py
# This is an auto-generated Django model module.
# You'll have to do the following manually to clean this up:
#   * Rearrange models' order
#   * Make sure each model has one field with primary_key=True
#   * Make sure each ForeignKey and OneToOneField has `on_delete` set to the desired behavior
#   * Remove `managed = False` lines if you wish to allow Django to create, modify, and delete the table
# Feel free to rename the models, but don't rename db_table values or field names.

import datetime

from django.contrib.auth.models import User
from django.core.cache import cache
from django.db import models
from django.utils.timezone import is_aware, is_naive

from animeflix_project import settings


class Utente(models.Model):
    account = models.OneToOneField(User, on_delete=models.CASCADE, db_column='account', primary_key=True)
    eta = models.IntegerField(blank=True, null=True)
    nazionalita = models.CharField(max_length=50, blank=True, default='')
    abbonato = models.BooleanField(default=False)
    avatar = models.ImageField(upload_to='avatar', default='avatar/avatar-default.png')

    class Meta:
        db_table = 'ANIMEFLIX_utente'

    def __str__(self):
        if not self.account.is_active:
            return "user deleted"
        return self.account.get_username()

    def get_default_avatar_path(self):
        upload_folder = self.avatar.field.upload_to
        default_name = upload_folder + '-default.png'
        default_path = upload_folder + '/' + default_name
        return default_path

    def get_account_lists(self):
        return Lista.objects.filter(id_account=self).all()

    def last_seen(self):
        return cache.get('seen_%s' % self.account.username)

    def is_online(self):
        last_seen = self.last_seen()
        if last_seen:
            now = datetime.datetime.now()
            if now > last_seen + datetime.timedelta(seconds=settings.USER_ONLINE_TIMEOUT):
                return False
            else:
                return True
        else:
            return False

    def delete(self, using=None, keep_parents=False):
        if 'default' not in self.avatar.name:
            self.avatar.storage.delete(self.avatar.name)
        return super().delete(using, keep_parents)


class Categoria(models.Model):
    descrizione = models.CharField(primary_key=True, max_length=30)

    class Meta:
        db_table = 'ANIMEFLIX_categoria'


class Genere(models.Model):
    descrizione = models.CharField(primary_key=True, max_length=20)

    class Meta:
        db_table = 'ANIMEFLIX_genere'


class Anime(models.Model):
    categoria = models.ForeignKey(Categoria, on_delete=models.DO_NOTHING, db_column='categoria')
    titolo = models.CharField(max_length=50)
    trama = models.TextField()
    copertina = models.TextField()
    stato = models.BooleanField()
    premium = models.BooleanField()
    n_serie = models.IntegerField(blank=True, null=True, default=0)
    tot_episodi = models.IntegerField(blank=True, null=True, default=0)
    avg_rating = models.FloatField(default=0)

    class Meta:
        db_table = 'ANIMEFLIX_anime'
        ordering = ['titolo']

    def __str__(self):
        return f'{self.titolo}_{self.id}'

    def update_serie_counter(self):
        self.n_serie = self.serie_set.count()
        self.save(update_fields=['n_serie'])

    @property
    def short_trama(self):
        return self.trama if len(self.trama) < 35 else (self.trama[:33] + '..')

    def get_series(self):
        return Serie.objects.select_related('id_anime').filter(id_anime=self.id).order_by('id')

    def last_ep(self):
        return Episodio.objects.select_related('id_anime').filter(id_anime=self.id).order_by('-data_car',
                                                                                             '-ora_car').first()


class Animegenere(models.Model):
    id_anime = models.ForeignKey(Anime, on_delete=models.DO_NOTHING, db_column='id_anime')
    id_genere = models.ForeignKey(Genere, on_delete=models.DO_NOTHING, db_column='id_genere')

    class Meta:
        db_table = 'ANIMEFLIX_anime_genere'
        unique_together = [['id_anime', 'id_genere']]


class Stagionedellanno(models.Model):
    stagione = models.CharField(max_length=10)
    anno = models.IntegerField()

    class Meta:
        db_table = 'ANIMEFLIX_stagionedellanno'
        unique_together = [['stagione', 'anno']]

    def __str__(self):
        return f'{self.stagione} {self.anno}'


class Serie(models.Model):
    numero = models.FloatField()
    id_anime = models.ForeignKey(Anime, on_delete=models.CASCADE, db_column='id_anime')
    id_stag_anno = models.ForeignKey(Stagionedellanno, on_delete=models.DO_NOTHING, db_column='id_stag_anno')
    nome = models.CharField(max_length=50)
    n_episodi = models.IntegerField(blank=True, null=True)

    class Meta:
        db_table = 'ANIMEFLIX_serie'
        unique_together = [['id', 'id_anime']]

    def __str__(self):
        return f'{self.nome}_{self.id}'

    def update_n_episodi(self):
        self.n_episodi = self.episodio_set.count()
        self.save(update_fields=['n_episodi'])

    def get_episodes(self):
        return Episodio.objects.select_related('id_serie').filter(id_serie=self.id)

    def save(self, force_insert=False, force_update=False, using=None,
             update_fields=None):
        self.id_anime.update_serie_counter()
        super().save()


class Episodio(models.Model):
    numero = models.FloatField()
    id_serie = models.ForeignKey(Serie, on_delete=models.CASCADE, db_column='id_serie')
    id_anime = models.ForeignKey(Anime, on_delete=models.CASCADE, db_column='id_anime')
    titolo = models.CharField(max_length=100)
    url_video = models.TextField()
    data_car = models.DateField(blank=True, null=True)
    ora_car = models.TimeField(blank=True, null=True)

    class Meta:
        db_table = 'ANIMEFLIX_episodio'
        unique_together = [['id', 'id_serie', 'id_anime']]

    def __str__(self):
        return f'{self.numero}_{self.titolo}_{self.id}'

    def daysPassed(self):
        delta = datetime.date.today() - self.data_car
        return delta.days

    def save(self, force_insert=False, force_update=False, using=None,
             update_fields=None):
        self.id_serie.update_n_episodi()
        super().save()


class Lista(models.Model):
    id = models.AutoField(primary_key=True)
    nome = models.CharField(max_length=12, null=False)
    id_account = models.ForeignKey(Utente, on_delete=models.CASCADE, to_field='account', db_column='id_account')

    class Meta:
        db_table = 'ANIMEFLIX_lista'
        unique_together = [['nome', 'id_account']]

    def get_animes(self):
        return ListaIncludeAnime.objects.filter(id_account=self.id_account, nome_lista=self).all()


class ListaIncludeAnime(models.Model):
    id_anime = models.ForeignKey(Anime, on_delete=models.CASCADE, db_column='id_anime')
    nome_lista = models.ForeignKey(Lista, on_delete=models.CASCADE, db_column='nome_lista', blank=True, null=True)
    id_account = models.ForeignKey(Utente, on_delete=models.CASCADE, db_column='id_account')

    class Meta:
        db_table = 'ANIMEFLIX_lista_include_anime'
        unique_together = [['id_anime', 'nome_lista', 'id_account']]


class Premium(models.Model):
    id = models.IntegerField(primary_key=True)
    durata = models.IntegerField(null=False)

    class Meta:
        db_table = 'ANIMEFLIX_premium'

    def __str__(self):
        return self.durata.__str__()


class AccountPremium(models.Model):
    id_account = models.ForeignKey(Utente, on_delete=models.CASCADE, db_column='id_account')
    id_premium = models.ForeignKey(Premium, on_delete=models.CASCADE, db_column='id_premium')
    data_inizio = models.DateField(auto_now_add=True)
    data_fine = models.DateField(editable=False)
    scaduto = models.BooleanField(default=False, editable=False)

    class Meta:
        db_table = 'ANIMEFLIX_account_premium'
        unique_together = [['id_account', 'id_premium']]

    def save(self, *args, **kwargs):
        offert = self.id_premium
        self.data_inizio = datetime.date.today()
        self.data_fine = self.data_inizio + datetime.timedelta(days=offert.durata)
        return super().save(*args, **kwargs)

    def delete(self, *args, **kwargs):
        self.id_account.abbonato = False
        self.id_account.save(update_fields=['abbonato'])
        return super().delete(*args, **kwargs)


class Evaluation(models.Model):
    author = models.ForeignKey(Utente, on_delete=models.CASCADE, db_column='author')
    anime = models.ForeignKey(Anime, on_delete=models.CASCADE, db_column='anime')
    title = models.CharField(blank=False, max_length=100)
    review = models.TextField(blank=False)
    vote = models.PositiveSmallIntegerField(null=False)
    creation_date = models.DateTimeField(auto_now_add=True, editable=False)
    mod_date = models.DateTimeField(auto_now=True)

    class Meta:
        db_table = 'ANIMEFLIX_evaluation'
        unique_together = [['author', 'anime']]
        ordering = ['creation_date']

    def creation_date_str(self):
        return self.creation_date.strftime("%d-%m-%Y")

    def mod_date_str(self):
        return self.mod_date.strftime("%d-%m-%Y")

auth_app/forms.py
from django import forms
from django.contrib.auth.models import User

from animeflix_app.models import Utente

LISTS = ['MyList', 'Seen']


class LoginForm(forms.Form):
    account = forms.CharField(
        error_messages={
            'invalid': 'Please use a valid email or username'
        },
        required=True,
        label="Email or Username*",
        widget=forms.TextInput(attrs={"class": "form-control form-input"})
    )

    password = forms.CharField(
        required=True,
        label="Password*",
        widget=forms.PasswordInput(attrs={"class": "form-control form-input"})
    )

    def clean_password(self):
        password = self.cleaned_data['password']
        if len(password) < 6:
            raise forms.ValidationError('Password must be at least 6 characters')

        if ' ' in password:
            raise forms.ValidationError('Password should not contain any space')
        return password


class RegistrationForm(forms.Form):
    username = forms.CharField(
        error_messages={
            'invalid': 'Please use a valid username'
        },
        required=True,
        label="Username*",
        widget=forms.TextInput(attrs={"class": "form-control form-input"})
    )
    email = forms.EmailField(
        error_messages={
            'invalid': 'Please use a valid email'
        },
        required=True,
        label="Email Address*",
        widget=forms.EmailInput(attrs={"class": "form-control form-input"})
    )

    password = forms.CharField(
        help_text='Passwords must be at least 6 characters, but no spaces',
        required=True,
        label="Password*",
        widget=forms.PasswordInput(attrs={"class": "form-control form-input"})
    )

    age = forms.IntegerField(
        required=False,
        min_value=0,
        widget=forms.NumberInput(attrs={"class": "form-control form-input"})
    )

    country = forms.CharField(
        required=False,
        widget=forms.TextInput(attrs={"class": "form-control form-input"})
    )

    def clean_password(self):
        password = self.cleaned_data['password']
        if len(password) < 6:
            raise forms.ValidationError('Password is too short')
        if ' ' in password:
            raise forms.ValidationError('Password should not contain any space')
        return password

    def clean_age(self):
        age = self.cleaned_data['age']
        if age == 0:
            raise forms.ValidationError('Please insert a valid age or leave blank')
        return age


class ProfileForm(forms.ModelForm):
    avatar = forms.ImageField(
        required=False,
        widget=forms.FileInput()
    )

    eta = forms.IntegerField(
        required=False,
        min_value=0,
        label="Age",
        widget=forms.TextInput(attrs={"class": "form-control form-input"})
    )

    nazionalita = forms.CharField(
        required=False,
        label="Country",
        widget=forms.TextInput(attrs={"class": "form-control form-input"})
    )

    class Meta:
        model = Utente
        fields = ['avatar', 'eta', 'nazionalita']


class AccountForm(forms.ModelForm):
    username = forms.CharField(
        error_messages={
            'invalid': 'Please use a valid username'
        },
        required=True,
        label="Username*",
        widget=forms.TextInput(attrs={"class": "form-control form-input"})
    )
    email = forms.EmailField(
        error_messages={
            'invalid': 'Please use a valid email'
        },
        required=True,
        label="Email Address*",
        widget=forms.EmailInput(attrs={"class": "form-control form-input"})
    )

    password = forms.CharField(
        required=True,
        label="Password*",
        widget=forms.PasswordInput(attrs={"class": "form-control form-input"}, render_value=True)
    )

    def clean_password(self):
        password = self.cleaned_data['password']
        if len(password) < 6:
            raise forms.ValidationError('Password must be at least 6 characters')

        if ' ' in password:
            raise forms.ValidationError('Password should not contain any space')
        return password

    class Meta:
        model = User
        fields = ['email', 'username', 'password']

auth_app/templates/auth_app/changePassword.html
{% extends 'base.html' %}

{% block title %}Enter new password{% endblock %}

{% block content %}

<section id="reset-password" class="container">
    <div class="row justify-content-center">
        <div class="col-5">
            <div class="card-body form-group py-5">
                <h1 class="card-title text-center mb-5">Set a new password</h1>

                <form method="POST" novalidate> {% csrf_token %}
                    {% for field in form %}
                        <div class="form-row d-flex justify-content-center mt-2">
                            <div class="form-group col-12 col-md-9">
                                <label for="{{ field.id_for_label }}" class="form-label">
                                    {% if 'password' in field.id_for_label %}
                                        <strong>New {{ field.label|lower }}</strong>
                                    {% elif 'account' in field.id_for_label %}
                                        <strong>Email address*</strong>
                                    {% endif %}
                                </label>
                                {{ field }}

                                {% if field.errors %}
                                    <div class="invalid-feedback">
                                        {{ field.errors }}
                                    </div>
                                {% endif %}
                            </div>
                        </div>
                    {% endfor %}

                    <div class="form-row d-flex justify-content-center my-4">
                        <div class="form-group col-12 col-md-9 d-flex justify-content-between">
                            <input type="submit" class="btn btn-primary" value="SAVE">
                            <a class="btn btn-primary" href="{% url 'login' %}">CANCEL</a>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</section>

{% endblock %}

auth_app/templates/auth_app/deleteAccountModal.html
<form action="{% url 'delete_account' utente.pk %}" method="post"> {% csrf_token %}
    <div id="del-account-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog modal-dialog-centered {% if utente.abbonato %}modal-lg{% endif %}">
            <div class="modal-content" >
                <div class="modal-header">
                    <h3 class="primary-text-color">Confirm delete</h3>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body text-center p-5">
                    {% if utente.abbonato %}
                        <h5>If you continue your premium subscription will be canceled.
                            <br>Are you sure?</h5>
                    {% else %}
                        <h5>Are you sure you want to delete your account?</h5>
                    {% endif %}
                </div>
                <div class="modal-footer d-flex justify-content-between">
                    <input type="submit" value="YES" class="btn btn-primary">
                    <button type="button" data-bs-dismiss="modal" class="btn btn-primary">NO</button>
                </div>
            </div>
        </div>
    </div>
</form>

auth_app/templates/auth_app/editAccount.html
{% extends 'base.html' %}
{% load static %}

{% block content %}
    <section id="edit-account">
        <div class="row justify-content-center">
            <div class="col-12 col-md-8">
                <div class="card-body form-group py-5">
                    <h1 class="card-title text-center">EDIT YOUR ACCOUNT</h1>

                    <form method="post" enctype="multipart/form-data" novalidate>
                        {% csrf_token %}

                        <div class="row justify-content-center my-4">
                            <div class="col-12 col-md-9">
                                <div class="form-row d-flex justify-content-end mt-3">
                                    <div class="form-group col-5 text-end pe-5">
                                        <label for="{{ user_form.avatar.id_for_label }}" class="form-label">
                                            <strong>{{ user_form.avatar.label }}</strong>
                                        </label>
                                    </div>
                                    <div class="form-group col d-flex">
                                        <img id="user_avatar" src="{{ object.avatar.url }}" class="img-thumbnail" width="70" alt="avatar"/>
                                        <div class="d-flex flex-column my-auto ps-3">
                                            {{ user_form.avatar }}
                                            <a id="default" href="">Choose default</a>
                                        </div>

                                        {% if user_form.avatar.errors %}
                                            <div class="invalid-feedback text-start">
                                                {{ user_form.avatar.errors }}
                                            </div>
                                        {% endif %}
                                    </div>
                                </div>

                                {% for field in account_form %}
                                    <div class="form-row d-flex justify-content-center mt-3">
                                        <div class="form-group col-5 text-end pe-5">
                                            <label for="{{ field.id_for_label }}" class="form-label">
                                                <strong>{{ field.label }}</strong>
                                            </label>
                                        </div>
                                        <div class="form-group col">
                                            {{ field }}

                                            {% if field.errors %}
                                                <div class="invalid-feedback">
                                                    {{ field.errors }}
                                                </div>
                                            {% endif %}
                                        </div>
                                    </div>
                                {% endfor %}

                                <div class="form-row d-flex justify-content-center mt-3">
                                    <div class="form-group col-5 text-end pe-5">
                                        <label for="{{ user_form.eta.id_for_label }}" class="form-label">
                                            <strong>{{ user_form.eta.label }}</strong>
                                        </label>
                                    </div>
                                    <div class="form-group col">
                                        {{ user_form.eta }}

                                        {% if user_form.eta.errors %}
                                            <div class="invalid-feedback">
                                                {{ user_form.eta.errors }}
                                            </div>
                                        {% endif %}
                                    </div>
                                </div>

                                <div class="form-row d-flex justify-content-center mt-3">
                                    <div class="form-group col-5 text-end pe-5">
                                        <label for="{{ user_form.nazionalita.id_for_label }}" class="form-label">
                                            <strong>{{ user_form.nazionalita.label }}</strong>
                                        </label>
                                    </div>
                                    <div class="form-group col">
                                        {{ user_form.nazionalita }}

                                        {% if user_form.nazionalita.errors %}
                                            <div class="invalid-feedback">
                                                {{ user_form.nazionalita.errors }}
                                            </div>
                                        {% endif %}
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="form-row d-flex justify-content-center">
                            <button type="submit" class="btn btn-primary me-5">
                                <input type="hidden" name="image_file" value="">
                                SAVE
                            </button>
                            <a href="{% url 'profile' %}" class="btn btn-primary">CANCEL</a>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </section>

    <script>
        function readURL(input) {
            if (input.files && input.files[0]) {
                let reader = new FileReader();

                reader.onload = function (e) {
                    $('img#user_avatar').attr('src', e.target.result);
                }
                reader.readAsDataURL(input.files[0]);
            }
        }

        $('input#id_avatar').change(function () {
            readURL(this);
        });

        $('a#default').click(function(e) {
            e.preventDefault();
            $('img#user_avatar').attr('src', {{ MEDIA_URL }} + '/avatar/avatar-default.png');
            $('input#id_avatar').val('');
            $('input[name="image_file"]').val('default-image');
        });
    </script>
{% endblock %}

auth_app/templates/auth_app/profile.html
{% extends 'base.html' %}
{% load static %}

{% block content %}
    {% if messages %}
        <div class="messages container">
            {% for message in messages %}
                <div class="row justify-content-center mb-2 px-3">
                    <div {% if message.tags %} class="col-12 col-md-8 alert alert-dismissible {{ message.tags }} shadow" {% endif %}>
                        <h5 class="text-center m-0">{{ message | safe }}</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                    </div>
                </div>
            {% endfor %}
        </div>
    {% endif %}

    <section id="user-profile" class="container">
        <div class="row justify-content-center">
            <div class="col-12 col-md-8">
                <div class="card-body background-light py-5">
                    <h1 class="card-title text-center mb-4">YOUR ACCOUNT</h1>

                    <table class="table table-responsive w-75 mx-auto">
                        <tbody class="dark-blue-text-color">
                            <tr>
                                <td colspan="2" class="text-center border-0">
                                    <img src="{{ utente.avatar.url }}" class="img-thumbnail" width="100" alt="avatar-icon">
                                </td>
                            </tr>
                            <tr class="fs-5">
                                <th class="text-end border-0">Email: </th>
                                <td class="text-center border-0">{{ utente.account.email }}</td>
                            </tr>
                            <tr class="fs-5">
                                <th class="text-end border-0">Username: </th>
                                <td class="text-center border-0">{{ utente.account.username }}</td>
                            </tr>
                            <tr class="fs-5">
                                <th class="text-end border-0">Age: </th>
                                <td class="text-center border-0">
                                    {% if utente.eta %}
                                        <h5>{{ utente.eta }}</h5>
                                    {% else %}
                                        <h5>-</h5>
                                    {% endif %}
                                </td>
                            </tr>
                            <tr class="fs-5">
                                <th class="text-end border-0">Country: </th>
                                <td class="text-center border-0">
                                    {{ utente.nazionalita }}
                                </td>
                            </tr>
                            <tr class="fs-5">
                                <th class="text-end border-0">Premium: </th>
                                <td class="text-center border-0">
                                    <label for="premium-checkbox"></label>
                                    <input class="form-check-input" id="premium-checkbox" type="checkbox" disabled>
                                    {% if utente.abbonato %}
                                        <p class="m-0 fs-6">Expiration date: {{ utente.accountpremium_set.first.data_fine }}</p>
                                    {% endif %}
                                </td>
                            </tr>
                            <tr class="fs-5 fst-italic">
                                <td colspan="2" class="text-center border-0 pt-3">
                                    Click <a href="{% url 'premium' %}">here</a>
                                    {% if utente.abbonato %}
                                        to change your subscription!
                                    {% else %}
                                        to subscribe to premium!
                                    {% endif %}
                                </td>
                            </tr>
                        </tbody>
                    </table>

                    <div class="row justify-content-center mt-5">
                        <div class="col d-flex justify-content-center">
                            <a href="{% url 'edit_account' utente.pk %}" class="btn btn-primary me-5">EDIT</a>
                            <button class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#del-account-modal">DELETE</button>
                            {% include 'auth_app/deleteAccountModal.html' %}
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>

<script>
    {% if utente.abbonato %}
        $('#premium-checkbox').prop('checked', true);
    {% endif %}
</script>
{% endblock %}